/*         RichiestaClient.java         */

import java.net.*;
import java.io.*;

public class RichiestaClient extends Thread{

    CliIODevice CliDev;
    remoteAddr indirizzoServer1;
    remoteAddr indirizzoServer2;
    String mode, server1,server2,giorno,fascia;
    int porta1,porta2;
	Utente utente;
	boolean successo=true;

  public RichiestaClient(CliIODevice CliDev, String mode){
    this.CliDev=CliDev;
    this.mode=mode;
	this.utente=CliDev.getUtente();
	indirizzoServer1=CliDev.getServerAddr1();
    indirizzoServer2 = CliDev.getServerAddr2();
    this.giorno=CliDev.getSelezione().getGiorno();
    this.fascia= CliDev.getSelezione().getFascia();
  }

  public void run(){
    if (mode.equals("AGG")) aggiornaDb();
     else if (mode.equals("PRE")) prenota();
       else if (mode.equals("REC")) recovery();
             else if (mode.equals("VER")) verificaUtente();
  }

  private void aggiornaDb(){
	
    Socket soc = null;
    String server1 = indirizzoServer1.getName();
    String server2 = indirizzoServer2.getName();
    int port1 = Integer.parseInt(indirizzoServer1.getPort());
    int port2 = Integer.parseInt(indirizzoServer2.getPort());
    // Accesso sempre al primo server
    CliDev.stampa("Tentativo di connessione con il server " + server1 + "   porta: " + port1+" ......");
    //richiesta di aggiornamento
    try{
       soc = new Socket(server1, port1);
       //invio richiesta 
       BufferedOutputStream bos = new BufferedOutputStream(soc.getOutputStream());
       DataOutputStream out = new DataOutputStream(bos);
	   out.writeUTF(utente.getUser());
	   out.writeUTF(utente.getPassword());
       out.writeUTF(mode);                 //invio mode=AGG
       out.flush();
       //ricezione dati
       BufferedInputStream bis = new BufferedInputStream(soc.getInputStream());
       DataInputStream in = new DataInputStream(bis);
       for (int f=0;f<4;f++)
          for (int g=0;g<7;g++)
           CliDev.matrice[f][g]=in.readInt();        //ricez matrice
       out.close();
       in.close();
       soc.close();
     }catch(IOException e){
         CliDev.stampa("FALLITO!");
         CliDev.stampa("Impossibile stabilire una connessione con il server "+server1);
         CliDev.stampa("Tentativo di connessione con il secondo server "+server2+"   porta: "+port2+" ......");
         try{
           soc = new Socket(server2, port2);
           //invio richiesta 
           BufferedOutputStream bos = new BufferedOutputStream(soc.getOutputStream());
           DataOutputStream out = new DataOutputStream(bos);
           out.writeUTF(utente.getUser());
           out.writeUTF(utente.getPassword());
           out.writeUTF(mode);                 //invio mode=AGG
           out.flush();
           //ricezione dati
           BufferedInputStream bis = new BufferedInputStream(soc.getInputStream());
           DataInputStream in = new DataInputStream(bis);
           for (int f=0;f<4;f++)
             for (int g=0;g<7;g++)
                CliDev.matrice[f][g]=in.readInt();        //ricez matrice
           out.close();
           in.close();
           soc.close();

         }catch(IOException exc){System.err.println("Aggiornamento db locale impossibile");
                                 exc.getMessage();
                                 CliDev.stampa("Al momento non  disponibile alcun server.");
                                 CliDev.stampa("Assicurarsi che i dati relativi ai server\n siano corretti\n quindi riprovare.");
                                 CliDev.stampa("Altrimenti riprovare pi tardi.");
								 successo=false;
								 CliDev.disabilitaUtente();
								 }
      }
	  if (successo){
      CliDev.stampa("Aggiornamento db locale terminato con successo.");
      CliDev.stampa("E' ora possibile prenotare");
	  }
      CliDev.setMatrice(CliDev.matrice);
      CliDev.setReqInCorso(false);
    }

   public void prenota(){
      Socket soc=null;
      boolean ok;

      if ((CliDev.getSelezione().getFascia() == "MATTINA") || (CliDev.getSelezione().getFascia() == "POMERIGGIO")) {
           server1=indirizzoServer1.getName();
           porta1=Integer.parseInt(indirizzoServer1.getPort());
           server2=indirizzoServer2.getName();
           porta2=Integer.parseInt(indirizzoServer2.getPort());
      }else{
         server2=indirizzoServer1. getName();
         porta2=Integer.parseInt(indirizzoServer1.getPort());
         server1=indirizzoServer2. getName();
         porta1=Integer.parseInt(indirizzoServer2.getPort());
      }
	  CliDev.cancella();
      CliDev.stampa("Tento di connettermi con il Serever "+server1+" porta: "+porta1);
      //invio richiesta
      try{
         soc = new Socket(server1, porta1);
         BufferedOutputStream bos = new BufferedOutputStream(soc.getOutputStream());
         DataOutputStream out = new DataOutputStream(bos);
         out.writeUTF(utente.getUser());
         out.writeUTF(utente.getPassword());
         out.writeUTF(mode);           //invio mode=PRE
         out.writeUTF(fascia);         //invio fascia
         out.writeUTF(giorno);         //invio giorno
         out.flush();
         //Ricezione dati
         BufferedInputStream bis = new BufferedInputStream(soc.getInputStream());
         DataInputStream in = new DataInputStream(bis);
         ok=in.readBoolean();
         if(ok){
            CliDev.stampa("Il posto  ora tuo.");
            int g=CliDev.giornoToNum(giorno);
            int f=CliDev.fasciaToNum(fascia);
            CliDev.matrice[f][g]=1;
         }else{
         CliDev.stampa("Spiacente, il posto  gi occupato");
         CliDev.stampa("Aggiornamento in corso");
         for (int f=0;f<4;f++)
           for (int g=0;g<7;g++)
             CliDev.matrice[f][g]=in.readInt();
         }
         File lastReq = new File("LastReq.sav");
         lastReq.delete();
         out.close();
         in.close();
         soc.close();
      }catch(IOException e){
             CliDev.stampa("Fallito! Impossibile stabilire una connessione con "+server1);
             CliDev.stampa("Tento di connettermi con il server "+server2+" porta: "+porta2);
             //invio richiesta alternativa
             try{
               soc = new Socket(server2, porta2);
               BufferedOutputStream bos = new BufferedOutputStream(soc.getOutputStream());
               DataOutputStream out = new DataOutputStream(bos);
               out.writeUTF(utente.getUser());
               out.writeUTF(utente.getPassword());
               out.writeUTF(mode);           //invio mode=PR
               out.writeUTF(fascia);         //invio fascia
               out.writeUTF(giorno);         //invio giorno
               out.flush();
               //Ricezione dati
               BufferedInputStream bis = new BufferedInputStream(soc.getInputStream());
               DataInputStream in = new DataInputStream(bis);
               ok=in.readBoolean();
               if(ok){
                     CliDev.stampa("Il posto  ora tuo.");
                     int g=CliDev.giornoToNum(giorno);
                     int f=CliDev.fasciaToNum(fascia);
                     CliDev.matrice[f][g]=1;
               }else{
                     CliDev.stampa("Spiacente, il posto  gi occupato");
                     CliDev.stampa("Aggiornamento in corso");
                     for (int f=0;f<4;f++)
                         for (int g=0;g<7;g++)
                            CliDev.matrice[f][g]=in.readInt();
               }
               File lastReq = new File("LastReq.sav");
               lastReq.delete();
               out.close();
               in.close();
               soc.close();
               }catch(IOException exc){
                   System.err.println("Collegamento impossibile: "+exc.getMessage());
                   CliDev.stampa("Collegamento con i server impossibile.");
               }
       }
       CliDev.setMatrice(CliDev.matrice);
       CliDev.setReqInCorso(false);
	   CliDev.disabilitaUtente();
    } 

    public void recovery(){
		Socket soc=null;
		boolean ok;
		String user, pass, giorno, fascia, serv1, serv2;
		int p1, p2;
		
		try{
			FileInputStream fis=new FileInputStream("LastReq.sav");
			BufferedInputStream bis=new BufferedInputStream(fis);
			DataInputStream dis=new DataInputStream(bis);
			serv1=dis.readUTF();
			p1=dis.readInt();
			serv2=dis.readUTF();
			p2=dis.readInt();
			user=dis.readUTF();
			pass=dis.readUTF();
			fascia=dis.readUTF();
			giorno=dis.readUTF();
			dis.close();
		}catch(FileNotFoundException e1){
			System.err.println("File LastReq.sav inesistente: "+e1.toString());
			return;
		}catch(IOException e2){
			System.err.println("Errore di lettura sul file LastReq.sav: "+e2.toString());
			return;
		}
		if ((fascia=="MATTINA")||(fascia=="POMERIGGIO")){
		    server1=serv1;
		    porta1=p1;
	     	server2=serv2;
	    	porta2=p2;
    	}else{
     		server2=serv1;
	     	porta2=p1;
    	   	server1=serv2;
     		porta1=p2;
    	}
    	CliDev.stampa("Tento di connettermi con il Serever "+server1+" porta: "+porta1);
    	//invio richiesta
    	try{
    	   soc = new Socket(server1, porta1);
    	   BufferedOutputStream bos = new BufferedOutputStream(soc.getOutputStream());
    	   DataOutputStream out = new DataOutputStream(bos);
    	   out.writeUTF(user);
    	   out.writeUTF(pass);
    	   out.writeUTF(mode);           //invio mode=REC
    	   out.writeUTF(fascia);         //invio fascia
    	   out.writeUTF(giorno);         //invio giorno
    	   out.flush();
    	   //Ricezione dati
    	   BufferedInputStream bis = new BufferedInputStream(soc.getInputStream());
    	   DataInputStream in = new DataInputStream(bis);
    	   ok=in.readBoolean();
    	   if(ok){
		   	  CliDev.stampa("Recovery: giorno "+giorno+" fascia "+fascia+" user "+user);
			  int g=CliDev.giornoToNum(giorno);
              int f=CliDev.fasciaToNum(fascia);
              CliDev.matrice[f][g]=1;
    	   }else {
		   	CliDev.stampa("La transazione precedente non  stata completata.");
			CliDev.stampa("Riprovare.");
	    	for (int f=0;f<4;f++)
               for (int g=0;g<7;g++)
                 CliDev.matrice[f][g]=in.readInt();        //ricez matrice
    	   }
		   out.close();
		   in.close();
		   File f=new File("LastReq.sav");
		   f.delete();
    	}catch(IOException e){
			CliDev.stampa("Fallita!!!\nTento di connettermi con "+server2+" porta: "+porta2);
			//richiesta alternativa
			try{
			   soc = new Socket(server2, porta2);
			   BufferedOutputStream bos = new BufferedOutputStream(soc.getOutputStream());
			   DataOutputStream out = new DataOutputStream(bos);
			   out.writeUTF(user);
			   out.writeUTF(user);
			   out.writeUTF(mode);           //invio mode=REC
			   out.writeUTF(fascia);         //invio fascia
			   out.writeUTF(giorno);         //invio giorno
			   out.flush();
			   //Ricezione dati
			   BufferedInputStream bis = new BufferedInputStream(soc.getInputStream());
			   DataInputStream in = new DataInputStream(bis);
			   ok=in.readBoolean();
			   if(ok){
			   	  CliDev.stampa("Recovery: giorno "+giorno+" fascia "+fascia+"user "+user);
				  int g=CliDev.giornoToNum(giorno);
			      int f=CliDev.fasciaToNum(fascia);
			      CliDev.matrice[f][g]=1;
			   }else {
			   	CliDev.stampa("La transazione precedente non  stata completata.");
				CliDev.stampa("Riprovare.");
				for (int f=0;f<4;f++)
			       for (int g=0;g<7;g++)
			         CliDev.matrice[f][g]=in.readInt();        //ricez matrice
			   }
			   out.close();
			   in.close();
			   File f=new File("LastReq.sav");
			   f.delete();
			}catch(IOException e2){
				System.err.println("Impossibile stabilire un collegamento con i server: "+e2.getMessage());
				CliDev.stampa("Collegamento con i server impossibile");
			}
    	}
    	CliDev.setMatrice(CliDev.matrice);
    	CliDev.setReqInCorso(false);	
    }
	
	public void verificaUtente(){
       CliDev.abilitaUtente();
    }
	

}
