                  /*              CoordinaServer.java                */


import java.net.*;
import java.io.*;


public class CoordinaServer extends Thread{

    Socket newSoc=null;
    ServIODevice servDev;
    String mode,user;
    DataInputStream in=null;
    String fascia, giorno;

    CoordinaServer(ServIODevice servDev, Socket newSoc){
      this.servDev=servDev;
      this.newSoc=newSoc;
    }

    public void run(){
      try{
         BufferedInputStream bis = new BufferedInputStream(newSoc.getInputStream());
         in = new DataInputStream(bis);
         mode=in.readUTF();
      }catch(IOException e){
          System.err.println("Altro  server down!\n");
      }
      servDev.stampa("Connessione con altro server: " + mode);
      if (mode.equals("INIT")) inviaAggiornamento();
      else if (mode.equals("MODIFY")) modificaDb(); 
	  else if (mode.equals("RESET")) resetDb();
	  else if (mode.equals("SAVE")) salva();
    }

    public void inviaAggiornamento(){
       try{
          DataOutputStream out = new DataOutputStream(new BufferedOutputStream(newSoc.getOutputStream()));
          for (int f=0;f<4;f++)
            for (int g=0;g<7;g++)
             out.writeInt(servDev.matrice.prenotazione[f][g]);
          out.flush();
          out.close();
       }catch(IOException e){
          System.err.println("altro server down");
       }
       servDev.stampa("Aggiornamento dell'altro server completato");
    }

    public void modificaDb(){
       boolean ok=false, myOk=false;
	   //ulteriori info
       try{
	        user=in.readUTF();
			fascia=in.readUTF();
			giorno=in.readUTF();	   
       }catch(IOException e){
	   	    System.err.println("Server2 down\n");
       }
       int fas=servDev.fasciaToNum(fascia);
       int gio=servDev.giornoToNum(giorno);
       if (servDev.matrice.libero(fas, gio)) {
	       myOk=true;
	       servDev.matrice.setPosto(user, fas, gio);
       }
	   if(myOk) ok=true;
	   else
	   	servDev.stampa("Problema di coerenza dei database!");
	   try{
	        DataOutputStream out=new DataOutputStream(new BufferedOutputStream(newSoc.getOutputStream()));
			out.writeBoolean(ok);
			out.flush();
			in.close();
			out.close();
			newSoc.close();
	   }catch(IOException e){
	        System.err.println("Server2 down\n");
	   }
    }
	
	public void resetDb(){
		servDev.resetDb();
	}	
	
	public void salva(){
		servDev.salvaDb();
	}
} 



