                            /*     ServIODevice      */
							
							
import java.awt.event.*;
import javax.swing.*; 
import java.awt.*;
import java.awt.Image;
import java.awt.Graphics;
import java.io.*;
import java.net.*;
import javax.swing.border.*;


public class ServIODevice extends JFrame implements ActionListener {

    public ServIODevice() {

       super("Server");
       Container contentPane=(JPanel)getContentPane();
	   contentPane.setLayout(new BorderLayout());
	   contentPane.setBackground(Color.blue);
	                                                   
       border3 = BorderFactory.createCompoundBorder(titledBorder2,
	                 BorderFactory.createEmptyBorder(5,5,5,5));
    
	   contentPane.setLayout(borderLayout1);												   

       mainPan = new JPanel();
       mainPan.setBackground(Color.lightGray);
	   mainPan.setBorder(border3);

       settingButt = new JButton("Configura");
	   visButt = new JButton("Visualizza");
	   cancButt = new JButton("Cancella");
	   resetButt = new JButton("RESET");
	   saveButt = new JButton("Salva su disco");
       settingButt.addActionListener(this);
       visButt.addActionListener(this);
       cancButt.addActionListener(this);
       resetButt.addActionListener(this);
       saveButt.addActionListener(this);
	   
       GridBagConstraints limiti = new GridBagConstraints();
       GridBagLayout gbl = new GridBagLayout();
       mainPan.setLayout(gbl);
	   
       info = new JTextArea();
       info.setEditable(false);
       scrollPane = new JScrollPane(info);
       scrollPane.setAutoscrolls(true);
 	   
       buildConstraints(limiti,1,0,2,1,5,2);
       limiti.fill=GridBagConstraints.HORIZONTAL;
       gbl.setConstraints(settingButt,limiti);
       mainPan.add(settingButt);
	   
       buildConstraints(limiti,0,1,2,1,5,3);
       gbl.setConstraints(resetButt,limiti);
       mainPan.add(resetButt);
	   
       buildConstraints(limiti,2,1,1,1,5,5);
       gbl.setConstraints(saveButt,limiti);
       mainPan.add(saveButt);
	   
       buildConstraints(limiti,0,2,4,6,30,35);
       limiti.fill=GridBagConstraints.BOTH;
       gbl.setConstraints(scrollPane,limiti);
       mainPan.add(scrollPane);
	   
       buildConstraints(limiti,0,8,2,1,0,0);
       gbl.setConstraints(cancButt,limiti);
       mainPan.add(cancButt);
	   
       buildConstraints(limiti,2,8,2,1,0,0);
       gbl.setConstraints(visButt,limiti);
       mainPan.add(visButt);
	   
       mainPan.setBackground(new Color(62, 97, 68));

       contentPane.add(mainPan);
 	   
	   finConfig.setSize(350,250);
	   finConfig.show();
	   finReset.setSize(300,85);
	   finSave.setSize(300,85);
	   
	   
	   // inizializzazione db
       this.inizializza();
       this.visualizza();
	   
       server = new Server(this, MyPortServ, MyPortCli);
	   
       //apertura Socket d'ascolto server
       server.attendiServer();
       //verifica utenti e password
       this.verificaUtente();
       //apertura socket d'ascolto  client
       server.attendiClient();
       info.append("In attesa del Client...\n");

    }   
	


	public void actionPerformed(ActionEvent e) {
		Object source=e.getSource();
		if(source==cancButt)
			info.setText("");
		if(source==visButt)
		    visualizza();
	    if(source==settingButt)
			finConfig.show();
		if(source==resetButt)
		    finReset.show();
		if(source==saveButt)
		    finSave.show();	
	}
 
	public static void main(String[] args) {
        final JFrame frame;
				try {
            UIManager.setLookAndFeel(
                UIManager.getSystemLookAndFeelClassName());
        } catch (Exception e) {
            System.err.println("Impossibile utilizzare lo stile "
                             + "di sistema: " + e);
        }

        frame = new ServIODevice();

        WindowListener l = new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
              frame.setVisible(false);
							frame.dispose();
            	System.exit(0);
            }
  			};
        frame.addWindowListener(l);
        frame.setSize(495,420);
				frame.setResizable(false);
				frame.setVisible(true);
	}
	
	
	public void resetDb()
		{
			String fileSave="Init.ini";
				try{
					FileOutputStream file=new FileOutputStream(fileSave);
					BufferedOutputStream buff=new BufferedOutputStream(file);
					DataOutputStream data=new DataOutputStream(buff);
			        for (int f=0;f<4;f++)
			        	for (int g=0;g<7;g++){
					    	data.writeInt(0);//posto
					    	this.matrice.prenotazione[f][g]=0;//azzero la memoria
					}
					data.close();
				}catch(IOException e){
					System.err.println("Errore sul reset di "+fileSave+": "+e.toString());
				}
			this.stampa("Effettuato reset");
	}
	
	public void salvaDb(){
	   String fileSave="Init.ini";
		 try{
			FileOutputStream file=new FileOutputStream(fileSave);
			BufferedOutputStream buff=new BufferedOutputStream(file);
			DataOutputStream data=new DataOutputStream(buff);
	        for (int f=0;f<4;f++)
	        	for (int g=0;g<7;g++){
			    	data.writeInt(this.matrice.prenotazione[f][g]);//posto
			}
			data.close();
	     }catch(IOException e){
			System.err.println("Errore sul salvataggio di "+fileSave+": "+e.toString());
		 }
	   this.stampa("Effettuato salvataggio su disco");
} 
	
	
	
	public void inizializza(){
       try{
          Socket soc = new Socket(server2, porta2);
          BufferedOutputStream bos = new BufferedOutputStream(soc.getOutputStream());
          DataOutputStream dos = new DataOutputStream(bos);
          dos.writeUTF("INIT");
          dos.flush();
          BufferedInputStream bis = new BufferedInputStream(soc.getInputStream());
          DataInputStream dis = new DataInputStream(bis);
          info.append("Inizializzo dal Server "+server2+"\n");
          for (int f=0;f<4;f++)
            for (int g=0;g<7;g++) matrice.prenotazione[f][g]=dis.readInt();
              dos.close();
          dis.close();
          soc.close();
       }catch(IOException e){
              info.append("Server "+ server2 +" down\n");
              this.inizializzaDaFile();
       }
    }//fine inizializza

    public void inizializzaDaFile(){
        info.append("Inizializzo da file Init.ini\n");
        String file = "Init.ini";
        try{
             FileInputStream fis = new FileInputStream(file);
			 BufferedInputStream bis = new BufferedInputStream(fis);
			 DataInputStream data = new DataInputStream(bis);
			 for (int f=0;f<4;f++)
			 	for (int g=0;g<7;g++)
					matrice.prenotazione[f][g]=data.readInt();
			 fis.close();	
        }catch(EOFException e1){
		     System.err.println("File "+file+" non corretto");
			 System.exit(1);
        }catch(IOException e2){
		     System.out.println("Errore: "+e2.toString());
			 System.exit(1);
        } 
    }

    private void verificaUtente(){

    }


    public void visualizza(){
        info.append("             LUN  MAR  MER  GIO  VEN  SAB  DOM\n");
        for (int f=0;f<4;f++){
         if (f==0)      info.append("MATTINA       ");
         else if (f==1) info.append("POMERIGGIO    ");
         else if (f==2) info.append("SERA          ");
         else if (f==3) info.append("NOTTE         ");
         for (int g=0;g<7;g++){
              info.append(matrice.prenotazione[f][g] + "    ");
              if (g==6) info.append("\n");
         }
       }
    }//fine visualizza

     public void stampa(String s){
         info.append(s + "\n");
     }


     public int fasciaToNum(String f){
        if(f.equals("MATTINA")) return 0;
        else if(f.equals("POMERIGGIO")) return 1;
        else if(f.equals("SERA")) return 2;
        else if(f.equals("NOTTE")) return 3;
        else return -1;
 
     }
 
     public int giornoToNum(String g){
        if(g.equals("LUNEDI"))return 0;
        else if(g.equals("MARTEDI"))return 1;
        else if(g.equals("MERCOLEDI"))return 2;
        else if(g.equals("GIOVEDI"))return 3;
        else if(g.equals("VENERDI"))return 4;
        else if(g.equals("SABATO"))return 5;
        else if(g.equals("DOMENICA"))return 6;
        else return -1;
     }
	 
	 public String getServer2(){
	 	return this.server2;
	 }
	 
	 public int getPort2(){
	 	return this.porta2;
	 }
	




	void buildConstraints(GridBagConstraints gbc,int gx,int gy,int gw,int gh,int wx,int wy){
			gbc.gridx=gx;
			gbc.gridy=gy;
			gbc.gridwidth=gw;
			gbc.gridheight=gh;
			gbc.weightx=wx;
			gbc.weighty=wy;
	}



       private JPanel mainPan;
	   private JButton settingButt;
       private JButton visButt;
	   private JButton cancButt;
	   private JButton resetButt;
	   private JButton saveButt;
	   private JTextArea info;
	   private JScrollPane scrollPane;
	   private Border border3;
	   private TitledBorder titledBorder2;
	   private BorderLayout borderLayout1 = new BorderLayout();
	   private finConfigServer finConfig = new finConfigServer(this);
	   private FinReset finReset = new FinReset(this);
	   private FinSave finSave = new FinSave(this);
	   String altroServer, altraPorta, portaClient, portaServer;
	   String server2;
       int porta2, MyPortCli, MyPortServ;
       Matrice matrice = new Matrice(4,7);
       Server server;


}