                    /*     ServiClient.java      */


import java.io.*;
import java.net.*;

public class ServiClient extends Thread{

  Socket soc=null;
  ServIODevice servDev;
  String user, password, mode;
  String fascia, giorno;
  DataInputStream in=null;

  public ServiClient(ServIODevice servDev, Socket soc){
   this.servDev=servDev;
   this.soc=soc;
  }
  
  public void run(){
   try{
     in = new DataInputStream(new BufferedInputStream(soc.getInputStream()));
     //Ricezione dati client
     user=in.readUTF();
     password=in.readUTF();
     mode=in.readUTF();
   }catch(IOException e){
     System.err.println("Errore durante il collegamento.Impossibile servire il client "+ e.getMessage());
   }
   servDev.stampa("Nuova connessione con "+user);
   servDev.stampa("Operazione:  "+mode);
   //Verifica utente
   //...
   //Verifica tipo di richiesta
   if (mode.equals("AGG")) aggiornaDbClient();
   else{
   	 //leggo ulteriori informazioni
     try{
      fascia=in.readUTF();
      giorno=in.readUTF();
     }catch(IOException e){
       System.err.println("Errore durante il collegamento.Impossibile servire il client "+ e.getMessage());
     }
   if (mode.equals("PRE")) prenota();
   else if (mode.equals("REC")) verificaPosto();
   else if (mode.equals("VER")) verificaUtente();
   }
  }

  public void aggiornaDbClient(){
    try{
     //invio aggiornamento db al client
     DataOutputStream out = new DataOutputStream(new BufferedOutputStream(soc.getOutputStream()));
     for (int f=0;f<4;f++)
       for (int g=0;g<7;g++)
         out.writeInt(servDev.matrice.prenotazione[f][g]);
     out.close();
     in.close();
     soc.close();
    }catch(IOException e){
      System.err.println("Errore durante il collegamento.Impossibile servire il client "+ e.getMessage());
    }
    servDev.stampa("Aggiornato db client "+user);
  }

  public void prenota(){
    boolean ok=false, myOk=false;

    int fas=servDev.fasciaToNum(fascia);
    int gio=servDev.giornoToNum(giorno);
    if (servDev.matrice.libero(fas, gio)){
	 myOk=true;
	 servDev.matrice.setPosto(user, fas, gio);
    }
    //coordinazione con server2
    if(myOk){
        ok=responsoAltroServer();
        if(!ok)
          servDev.stampa("Incoerenza tra db dei due server");
    }
    try{
       DataOutputStream out = new DataOutputStream(new BufferedOutputStream(soc.getOutputStream()));
       out.writeBoolean(ok);
       if (!ok)
         for(int f=0;f<4;f++)
           for(int g=0;g<7;g++)
             out.writeInt(servDev.matrice.prenotazione[f][g]);
       out.flush();
       in.close();
       out.close();
       soc.close();
    }catch(IOException e){
         System.err.println("Errore durante il collegamento.Impossibile servire il client "+ e.getMessage());
    }
  }

  public void verificaPosto(){
    boolean ok=false, myOk=false;
  
    int fas=servDev.fasciaToNum(fascia);
    int gio=servDev.giornoToNum(giorno);
    if (servDev.matrice.libero(fas, gio)) {
	 myOk=true;
	 servDev.matrice.setPosto(user, fas, gio);
    }
    //coordinazione con server2
    if(myOk){
         ok=responsoAltroServer();
         if(!ok)
         servDev.stampa("Incoerenza tra db dei due server");
    }else{
        if(servDev.matrice.utente[fas][gio].equals(user)) ok=true;
    }
    try{
       DataOutputStream out = new DataOutputStream( new BufferedOutputStream(soc.getOutputStream()));
       out.writeBoolean(ok);
       if(!ok)
         for(int f=0;f<4;f++)
           for(int g=0;g<7;g++)
             out.writeInt(servDev.matrice.prenotazione[f][g]);
       out.flush();
       in.close();
       out.close();
       soc.close();
    } catch(IOException e){
        System.err.println("Errore durante il collegamento.Impossibile servire il client "+ e.getMessage());
    }
  }
  
  public void verificaUtente(){
  }

  public boolean responsoAltroServer(){
    boolean responso=false;

    try{
       Socket coordSoc = new Socket(servDev.getServer2(),servDev.getPort2());
       DataOutputStream dos = new DataOutputStream( new BufferedOutputStream(coordSoc.getOutputStream()));
       dos.writeUTF("MODIFY");
       dos.writeUTF(user);
       dos.writeUTF(fascia);
       dos.writeUTF(giorno);
       dos.flush();
       //responso dell'altro server
       DataInputStream dis = new DataInputStream(new BufferedInputStream(coordSoc.getInputStream()));
       responso=dis.readBoolean();
       dos.close();
       dis.close();
       coordSoc.close();
     }catch(IOException e){
        servDev.stampa("Altro server down");
        return true;
     }
     return responso;
   }
 
}
